<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="80px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="userId" label="昵称">
                <el-input v-model="user.nickname"></el-input>
            </el-form-item>
            <el-form-item prop="payMethod" label="支付方式">
                <el-select v-model="formData.payMethod" clearable filterable placeholder="请选择">
                    <el-option
                        v-for="item in payMethodOptions"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                    >
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="paidAt" label="支付时间">
                <el-date-picker
                    v-model="formData.paidAt"
                    type="datetime"
                    value-format="yyyy-MM-dd HH:mm:ss"
                    placeholder="选择日期时间"
                >
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="status" label="订单状态">
                <el-select v-model="formData.status" clearable filterable placeholder="请选择">
                    <el-option v-for="item in statusOptions" :key="item.value" :label="item.label" :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="transactionId" label="订单号">
                <el-input v-model="formData.transactionId"></el-input>
            </el-form-item>
            <el-form-item prop="name" label="名称">
                <el-input v-model="formData.name"></el-input>
            </el-form-item>
            <!--<el-form-item prop="setId" label="充值套餐">
                <el-input v-model="formData.setId"></el-input>
            </el-form-item>-->
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'OrderInfoEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('orderInfo/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                    if (res.user != null) {
                        this.user = res.user;
                    }
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            user: {},
            rules: {
                // userId: [
                //     {
                //         required: true,
                //         message: '请输入userId',
                //         trigger: 'blur'
                //     }
                // ],
                status: [
                    {
                        required: true,
                        message: '请输入订单状态',
                        trigger: 'blur'
                    }
                ]
            },
            payMethodOptions: [
                { label: '微信', value: 'WEIXIN' },
                { label: '余额', value: 'YUE' }
            ],
            statusOptions: [
                { label: '未支付', value: 'UNPAID' },
                { label: '已支付', value: 'PAID' },
                { label: '已取消', value: 'CANCELLED' },
                { label: '线下支付', value: 'OFFLINE_PAID' }
            ]
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/orderInfo/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/orderInfo/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
